/* Copyright (C) 2003-2008 VA007219 */
#include <stdio.h>
#include <io.h>
#include <errno.h>
#include <windows.h>
#include <tchar.h>
#include <shlobj.h>

extern _TCHAR *pgname;
_TCHAR *getinikey(_TCHAR *av0,_TCHAR *section,_TCHAR *key);
void setinikey(_TCHAR *av0,_TCHAR *section,_TCHAR *key,_TCHAR *string);
int msgbox(HWND hWnd,UINT uType,_TCHAR *fmt, ...);

static _TCHAR outdir[LONGMAX_PATH + 1];

static int CALLBACK BrowseCallbackProc(HWND hWnd,UINT uMsg,LPARAM lParam,LPARAM lpData)
{
/*_tprintf(_T("uMsg= %d  "),uMsg);*/
    switch ( uMsg ) {
      case BFFM_INITIALIZED: /* 1 */
        SendMessage(hWnd,BFFM_SETSELECTION,(WPARAM)TRUE,lpData);
        return 0;
      case BFFM_SELCHANGED: /* 2 */
/*BFFM_SETSTATUSTEXT
Sets the status text. Set lpData to point to a null-terminated string with the desired text. 
wParam. Not used.
lParam. A pointer to a null-terminated Unicode string containing the desired text.
*/
        if ( SHGetPathFromIDList((LPCITEMIDLIST)lParam,outdir) ) {
/*_tprintf(_T("outdir= %s\n"),outdir);*/
            SendMessage(hWnd,BFFM_ENABLEOK,(WPARAM)TRUE,(LPARAM)TRUE);
            SendMessage(hWnd,BFFM_SETSTATUSTEXT,(WPARAM)0,(LPARAM)outdir);
        } else {
            SendMessage(hWnd,BFFM_ENABLEOK,(WPARAM)TRUE,(LPARAM)FALSE);
            SendMessage(hWnd,BFFM_SETSTATUSTEXT,(WPARAM)0,(LPARAM)_T(""));
        }
        return 0;
      case BFFM_VALIDATEFAILED: /* A 3 W 4 */
        SendMessage(hWnd,BFFM_ENABLEOK,(WPARAM)TRUE,(LPARAM)FALSE);
        return 1;
      default:
        return 0;
    }
}

int newdiag = 2;
/* 2:not tested  1:use newdiag 0:use olddiag */

int usenewdiag(void)
{
    if ( newdiag == 2 ) {
        if ( lstrcmp(getinikey(pgname,_T("SHBrowseForFolder"),_T("BIF_NEWDIALOGSTYLE")),_T("1")) == 0 ) {
            newdiag = 1;
        } else {
            newdiag = 0;
        }
    }
    return newdiag;
}

static int coinit = 0;
static _TCHAR szCurDir[LONGMAX_PATH + 1]; // KB416185

_TCHAR *seldir(HWND hWnd,_TCHAR *indir,_TCHAR *title)
{
    BROWSEINFO bi;
    LPITEMIDLIST pidl;
    int sts;
    UINT em;

    GetCurrentDirectory(sizeof szCurDir / sizeof szCurDir[0] - 1, szCurDir); // KB416185
    if ( usenewdiag()  == 1 ) {
        if ( coinit == 0 ) {
            CoInitialize(NULL);
            coinit = 1;
        };
    }
    bi.hwndOwner = hWnd;
    bi.pidlRoot = 0;
    bi.pszDisplayName = outdir;
    bi.lpszTitle = title == NULL ? _T("select folder") : title;
    bi.ulFlags = BIF_RETURNONLYFSDIRS;
    if ( newdiag ) {
        bi.ulFlags |= BIF_EDITBOX | BIF_NEWDIALOGSTYLE | BIF_VALIDATE;
    } else {
        bi.ulFlags |= BIF_STATUSTEXT;
/* BIF_STATUSTEXT
Include a status area in the dialog box. The callback function can set the status text by sending messages to the dialog box. This flag is not supported when BIF_NEWDIALOGSTYLE is specified.
*/
    }
    bi.lpfn = BrowseCallbackProc;
    if ( _taccess(indir,0) == EACCES ) {
        bi.lParam = (LPARAM)szCurDir;
    } else {
        bi.lParam = (LPARAM)indir;
    }
    bi.iImage = 0;

    em = SetErrorMode(SEM_FAILCRITICALERRORS);
    pidl = SHBrowseForFolder(&bi);
    SetErrorMode(em);
    SetCurrentDirectory(szCurDir); // KB416185
    if ( pidl == NULL ) return NULL;
    sts = SHGetPathFromIDList(pidl,outdir);
    CoTaskMemFree(pidl);
    if ( sts ) {
        return outdir;
    } else {
#ifndef GUISUB
        _ftprintf(stderr,_T("bad folder - not a part of the file system.\n"));
#else
        msgbox(NULL,MB_OK | MB_ICONWARNING,_T("bad folder - not a part of the file system."));
#endif
        return NULL;
    }
}

/*
int _tmain(int argc,_TCHAR **argv)
{
    HWND hWnd;

    hWnd = 0;
    CoInitialize(NULL);
    _tprintf(_T("%s\n"),seldir(hWnd,_T("C:\\")));
    return 0;
}
*/
