/* Copyright (C) 2005-2011 VA007219 */
#include <windows.h>
#include <stdlib.h>
#include <tchar.h>
#ifndef INVALID_FILE_ATTRIBUTES
#define INVALID_FILE_ATTRIBUTES ((DWORD)-1)
#endif
#define S_ARCH         0x0001           /* FILE_ATTRIBUTE_ARCHIVE */
#define S_SYSTEM       0x0002           /* FILE_ATTRIBUTE_SYSTEM */
#define S_HIDDEN       0x0004           /* FILE_ATTRIBUTE_HIDDEN */
#define S_RDONLY       0x0008           /* FILE_ATTRIBUTE_READONLY */
#define S_IFCMPRS      0x10000          /* FILE_ATTRIBUTE_COMPRESSED */
#define _S_IFCMPRS     S_IFCMPRS
#define S_IFENCRYPT    0x20000          /* FILE_ATTRIBUTE_ENCRYPTED */
#define _S_IFENCRYPT   S_IFENCRYPT
#define S_IFRPRS       0x40000          /* FILE_ATTRIBUTE_REPARSE_POINT */
#define _S_IFRPRS      S_IFRPRS
#define S_IFSPRS       0x80000          /* FILE_ATTRIBUTE_SPARSE_FILE */
#define _S_IFSPRS      S_IFSPRS
// #define _A_NORMAL       0x00    /* Normal file - No read/write restrictions */
// #define _A_RDONLY       0x01    /* Read only file */
// #define _A_HIDDEN       0x02    /* Hidden file */
// #define _A_SYSTEM       0x04    /* System file */
// #define _A_SUBDIR       0x10    /* Subdirectory */
// #define _A_ARCH         0x20    /* Archive file */
#define _A_CMPRS    0x100        /* FILE_ATTRIBUTE_COMPRESSED */
#define _A_ENCRYPT  0x200        /* FILE_ATTRIBUTE_ENCRYPTED */
#define _A_RPRS     0x400        /* FILE_ATTRIBUTE_REPARSE_POINT */
#define _A_SPRS     0x800        /* FILE_ATTRIBUTE_SPARSE_FILE */
#ifdef _UNICODE
#define std_findfirst64(a,b) std_findfirst64W(a,b)
#define std_findnext64(a,b) std_findnext64W(a,b)
#else
#define std_findfirst64(a,b) std_findfirst64A(a,b)
#define std_findnext64(a,b) std_findnext64A(a,b)
#endif

struct std_stat64 {
    int          st_dev;
    unsigned int st_mode;
    int          st_nlink;
    int          st_uid;
    int          st_gid;
    int          st_rdev;
    __int64      st_size;
    __int64      st_atime;
    __int64      st_mtime;
    __int64      st_ctime;
    DWORD        dwReserved0;
};

struct std_find_data64 {
    unsigned int attrib;
    __int64      time_create;
    __int64      time_access;
    __int64      time_write;
    __int64      size;
    _TXCHAR      name[_MAX_PATH];
    _TCHAR       cAlternateFileName[14];
    WIN32_FIND_DATA w32_finddata;
};

struct std_tm64 {
    int          tm_sec;
    int          tm_min;
    int          tm_hour;
    int          tm_mday; /* 1 -- 31 */
    int          tm_mon;  /* 0:Jan -- 11:Dec */
    int          tm_year; /* tm_year + 1900 = YYYY */
    int          tm_wday; /* 0:Sun -- 6:Sat */
    int          tm_yday; /* 0:1,Jan -- 365 */
    int          tm_isdst; /* VOID */
    int          tm_msec;
};

int std_findfirst64(_TXCHAR *,struct std_find_data64*);
int std_findnext64(int,struct std_find_data64*);
int std_findclose(int);
int std_stat64(_TXCHAR *,struct std_stat64*);
struct std_tm64 *std_localtime64(__int64*);
void doserrno(int win32err);
