#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>
#include <conio.h>
#include <windows.h>
#include <tchar.h>
#include <errno.h>
#include <crtdbg.h>
/*
#define iskanji(x) ( ((x) >= 0x81 && (x) <= 0x9f) || ((x) >= 0xe0 && (x) <= 0xfc) )
*/
#define STRINGIFY(s)   STRINGIFY_(s)
#define STRINGIFY_(s)  #s
#define LINE STRINGIFY(__LINE__)
#define TLINE _T(LINE)
#include "std64.h"

_TCHAR *dirname(_TCHAR *p);
_TCHAR *newname(_TCHAR *dir,_TCHAR *name);

_TCHAR *nalloc(int n)
{
    if ( n < 256 ) {
        return malloc(256);
    } else {
        return malloc(n);
    }
}

_TCHAR *subtruepath(_TCHAR *file)
{
    _TCHAR *p;
    _TCHAR *q;
    _TCHAR *dir;
    _TCHAR *tdir;
    WIN32_FIND_DATA FindFileData;
    HANDLE hFind;
    int len;
    int blen;

    blen = _tcslen(file) + LONGMAX_PATH + 2;
    p = nalloc((blen) * sizeof(_TCHAR));
    lstrcpy(p,file);

#ifdef UNICODE
    if ( *p == '\\' && *(p + 1) == '\\' && *(p + 2) == '?' && *(p + 3) == '\\' && std_istalpha(*(p + 4)) && *(p + 5) == ':' && *(p + 6) == '\\' && *(p + 7) == 0 ) { /* \\?\a:\ */
        return p;
    }
    if ( *p == '\\' && *(p + 1) == '\\' && *(p + 2) == '?' && *(p + 3) == '\\' && _totlower(*(p + 4)) == 'u' && _totlower(*(p + 5)) == 'n' && _totlower(*(p + 6)) == 'c' && *(p + 7) == '\\' && *(p + 8) == 0 ) { /* \\?\unc\ */
        return p;
    }
#else
    if ( std_istalpha(*p) && *(p + 1) == ':' && (*(p + 2) == '\\' || *(p + 2) == '/') && *(p + 3) == 0 ) { /* a:\ */
        return p;
    }
    if ( *p == '\\' && *(p + 1) == '\\' && *(p + 2) != '?' && netdrive(p) ) { /* \\pc \\pc\xxxx \\pc\xxxx\ */
        return p;
    }
#endif

    hFind = FindFirstFile(p,&FindFileData);
    if ( hFind == INVALID_HANDLE_VALUE ) {
        return p;
    } else {
        do {
            dir = dirname(p);
            if ( dir == NULL ) {
                FindClose(hFind);
                return dir;
            }
            tdir = subtruepath(dir);
            if ( tdir == NULL ) {
                FindClose(hFind);
                return tdir;
            }
            free(dir);
            if ( lstrcmp(FindFileData.cFileName,_T(".")) == 0 || lstrcmp(FindFileData.cFileName,_T("..")) == 0 ) continue;
            free(p);
            p = newname(tdir,FindFileData.cFileName);
            FindClose(hFind);
            free(tdir);
            return p;
        } while ( FindNextFile(hFind,&FindFileData) != 0 );
        FindClose(hFind);
    }
    return p;
}

_TCHAR *longtruepath(_TCHAR *file)
{
    _TCHAR *p;
    _TCHAR *q;
    _TCHAR *r;
    int c;

    if ( file == NULL || *file == 0 ) {
        p = nalloc(2 * sizeof(_TCHAR));
        *p = 0;
        return p;
    }
    if ( *file == '\\' && *(file + 1) == '\\' && *(file + 2) == 0 ) { /* \\ */
        p = nalloc(3 * sizeof(_TCHAR));
        _stprintf(p,_T("\\\\"));
        return p;
    }
#ifdef UNICODE
    if ( *file == '\\' && *(file + 1) == '\\' && *(file + 2) == '?' && *(file + 3) == 0 ) { /* \\? */
        p = nalloc(4 * sizeof(_TCHAR));
        _stprintf(p,_T("\\\\?"));
        return p;
    }
    if ( *file == '\\' && *(file + 1) == '\\' && *(file + 2) == '?' && *(file + 3) == '\\' && *(file + 4) == 0 ) { /* \\?\ */
        p = nalloc(5 * sizeof(_TCHAR));
        _stprintf(p,_T("\\\\?\\"));
        return p;
    }
#endif
    p = nalloc((LONGMAX_PATH + 5) * sizeof(_TCHAR));
    if ( *file == '\\' && *(file + 1) == '\\' && *(file + 2) == '.' && *(file + 3) == '\\' ) { /* \\.\~ */
        lstrcpy(p,file);
        return p;
    }
    if ( GetFullPathName(file,LONGMAX_PATH + 5,p,&r) == 0 ) {
        /* _ftprintf(errout,_T("%s: Invalid File Name. Get Last Error reports %d\n"),file,GetLastError ()); */
        lstrcpy(p,file);
        return p;
    }
#ifdef UNICODE
    if ( std_istalpha(*p) && *(p + 1) == ':' && *(p + 2) == '\\' ) { /* a:\~ -> \\?\A:\~ */
        c = *p;
        if ( _istlower(c) ) {
            *p = _totupper(c);
        }
        q = malloc((_tcslen(p) + 5) * sizeof(_TCHAR));
        _stprintf(q,_T("\\\\?\\%s"),p);
        r = subtruepath(q);
        free(q);
        return r;
    }
    if ( *p == '\\' && *(p + 1) == '\\' && *(p + 2) != '?' ) { /* \\pc \\pc\xxxx \\pc\xxxx\... -> \\?\~ */
        q = malloc((_tcslen(p) + 9) * sizeof(_TCHAR));
        _stprintf(q,_T("\\\\?\\UNC\\%s"),p + 2);
        r = subtruepath(q);
        free(q);
        return r;
    }
    if ( *p == '\\' && *(p + 1) == '\\' && *(p + 2) == '?' && *(p + 3) == '\\' && std_istalpha(*(p + 4)) && *(p + 5) == ':' && *(p + 6) == '\\' ) { /* \\?\A:\~ */
        c = *(p + 4);
        if ( _istlower(c) ) {
            *(p + 4) = _totupper(c);
        }
    }
#else
    if ( std_istalpha(*p) && *(p + 1) == ':' && *(p + 2) == '\\' ) { /* a:\~ -> \\?\A:\~ */
        c = *p;
        if ( _istlower(c) ) {
            *p = _totupper(c);
        }
    }
#endif
    q = subtruepath(p);
    free(p);
    return q;
}

_TCHAR *truepath(_TCHAR *file)
{
    _TCHAR *p;
    _TCHAR *q;
    _TCHAR *r;
    int c;

    if ( file == NULL || *file == 0 ) {
        p = nalloc(2 * sizeof(_TCHAR));
        *p = 0;
        return p;
    }
    if ( *file == '\\' && *(file + 1) == '\\' && *(file + 2) == 0 ) { /* \\ */
        p = nalloc(3 * sizeof(_TCHAR));
        _stprintf(p,_T("\\\\"));
        return p;
    }
#ifdef UNICODE
    if ( *file == '\\' && *(file + 1) == '\\' && *(file + 2) == '?' && *(file + 3) == 0 ) { /* \\? */
        p = nalloc(4 * sizeof(_TCHAR));
        _stprintf(p,_T("\\\\?"));
        return p;
    }
    if ( *file == '\\' && *(file + 1) == '\\' && *(file + 2) == '?' && *(file + 3) == '\\' && *(file + 4) == 0 ) { /* \\?\ */
        p = nalloc(5 * sizeof(_TCHAR));
        _stprintf(p,_T("\\\\?\\"));
        return p;
    }
#endif
    p = nalloc((LONGMAX_PATH + 5) * sizeof(_TCHAR));
    if ( *file == '\\' && *(file + 1) == '\\' && *(file + 2) == '.' && *(file + 3) == '\\' ) { /* \\.\~ */
        lstrcpy(p,file);
        return p;
    }
    if ( GetFullPathName(file,LONGMAX_PATH + 5,p,&r) == 0 ) {
        /* _ftprintf(errout,_T("%s: Invalid File Name. Get Last Error reports %d\n"),file,GetLastError ()); */
        lstrcpy(p,file);
        return p;
    }
#ifdef UNICODE
    if ( std_istalpha(*p) && *(p + 1) == ':' && *(p + 2) == '\\' ) { /* a:\~ -> \\?\A:\~ */
        c = *p;
        if ( _istlower(c) ) {
            *p = _totupper(c);
        }
        q = malloc((_tcslen(p) + 5) * sizeof(_TCHAR));
        _stprintf(q,_T("%s"),p);
        r = subtruepath(q);
        free(q);
        return r;
    }
    if ( *p == '\\' && *(p + 1) == '\\' && *(p + 2) != '?' ) { /* \\pc \\pc\xxxx \\pc\xxxx\... -> \\?\~ */
        q = malloc((_tcslen(p) + 9) * sizeof(_TCHAR));
        _stprintf(q,_T("\\\\%s"),p + 2);
        r = subtruepath(q);
        free(q);
        return r;
    }
    if ( *p == '\\' && *(p + 1) == '\\' && *(p + 2) == '?' && *(p + 3) == '\\' && std_istalpha(*(p + 4)) && *(p + 5) == ':' && *(p + 6) == '\\' ) { /* \\?\A:\~ */
        c = *(p + 4);
        if ( _istlower(c) ) {
            *(p + 4) = _totupper(c);
        }
    }
#else
    if ( std_istalpha(*p) && *(p + 1) == ':' && *(p + 2) == '\\' ) { /* a:\~ -> \\?\A:\~ */
        c = *p;
        if ( _istlower(c) ) {
            *p = _totupper(c);
        }
    }
#endif
    q = subtruepath(p);
    free(p);
    return q;
}
